/* XPLog -- an PPP-Dialer and Phonecost Program
 * Copyright (C) 1998 Stefan Kraus
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */ 

#include "xplog.h"

/* German CityPlus Rates */
float cityplus;
float protcity;

/* Preference Datas */
struct xplog xplogs;    /* Preference Datas */
struct iedata xpie;     /* Import/Export Datas */

/* Filehandle */
FILE *fh; 

/* String working */
const char *strdef;
char APuffer[256],BPuffer[256],CPuffer[256];
int a,b;

/* HomeDirectory */
char *user;
char xpuser[1024]="";

/* XPLog Restart Flag */
int xpfl=0;

main(int argc, char *argv[])
{
   struct xplMainGui    xplMG;

   /* Connection Flag */
   int                  QPLcon = 0;
   struct stat          statpuff;
   long                 atime,btime;
   struct tm            *atm,*btm;
   char                 atimer[20],btimer[20];

   /* GUI Format */
   int                  guif = 0;

   /* Rates Table Initialize */
   initrates();

   /* HomeDirectory */
   user=getenv("HOME");
   strcpy(xpuser,user);
  
   /* Default Prefs */
   /* Window Position */
   xplogs.winpos=1;
   /* Script-Datas */
   strcpy(xplogs.pppstart,"");
   strcpy(xplogs.pppstop,"");
   /* Provider-Name */
   strcpy(xplogs.provider,"");
   /* User Buttons */
   strcpy(xplogs.usera,_xpl_user1);
   strcpy(xplogs.useraa,"");
   strcpy(xplogs.userb,_xpl_user2);
   strcpy(xplogs.userbb,"");
   strcpy(xplogs.userc,_xpl_user3);
   strcpy(xplogs.usercc,"");
   /* Phonebill Protokol */
   xplogs.PBProt=1;
   /* Basic Rates */
   xplogs.xpbr=0;
   xplogs.xprent=0;
   xplogs.xpcredit=0;
   /* Free Window Position */
   xplogs.FreeMove=0;
   xplogs.xpos=0;
   xplogs.xpos=0;
   /* Iconify */
   xplogs.iconify=0;
   /* No Redial */
   xplogs.noredial=0;
   /* Deal Protection */
   for (a=0 ; a<7 ; a++)
   {
      for (b=0 ; b<24 ; b++)
      {
         xplogs.xpDP[a][b]='\0';
      }
   }

   XWindowAttributes attr;
   int            X11Flag=0;

   /* Mouseposition - Mouse Datas */
   int            winx,winy;
   unsigned int   wink;
   int            icommand; /* Internal Command Code */

  fl_initialize(&argc, argv, "FormDemo", 0, 0);

  /* Load Pref */
  /* create preffile path */
  strcpy(APuffer,xpuser);
  strcat(APuffer,"/.xpl.rc");

  /* Check ConfigurationFileFormat */
  if ((fh=fopen(APuffer,"r"))!=NULL)
    {
      /* Windows Position */
      if (fgets(CPuffer,255,fh)!=NULL)
        {
          memmove((CPuffer+strlen(CPuffer))-1,(CPuffer+strlen(CPuffer)),1);
        }
      fclose(fh);
    }

  /* Configuration File V1.00 */
  if (strcmp(CPuffer,"XPLOG1.00")==0)
    {
      Viewerror(5);

      /* read from preffile */
      if ((fh=fopen(APuffer,"r"))!=NULL)
        {
          /* Windows Position */
          if (fgets(BPuffer,255,fh)!=NULL)
            {
              a=fread(&xplogs,sizeof(xplog),1,fh);
            }
          fclose(fh);
        }
      strcpy(CPuffer,"");
    }

  /* Configuration File V1.01 */
  if (strcmp(CPuffer,"XPLOG1.01")==0)
    {
      Viewerror(5);

      /* read from preffile */
      if ((fh=fopen(APuffer,"r"))!=NULL)
        {
          /* Windows Position */
          if (fgets(BPuffer,255,fh)!=NULL)
            {
              a=fread(&xplogs,sizeof(xplog),1,fh);
            }
          fclose(fh);
        }
      strcpy(CPuffer,"");
    }

  /* Configuration File V1.02 */
  if (strcmp(CPuffer,"XPLOG1.02")==0)
    {
      /* read from preffile */
      if ((fh=fopen(APuffer,"r"))!=NULL)
        {
          /* Windows Position */
          if (fgets(BPuffer,255,fh)!=NULL)
            {
              a=fread(&xplogs,sizeof(xplog),1,fh);
            }
          fclose(fh);
        }
      strcpy(CPuffer,"");
    }

  /* Configuration File V1.03 */
  if (strcmp(CPuffer,"XPLOG1.03")==0)
    {
      /* read from preffile */
      if ((fh=fopen(APuffer,"r"))!=NULL)
        {
          /* Windows Position */
          if (fgets(BPuffer,255,fh)!=NULL)
            {
              a=fread(&xplogs,sizeof(xplog),1,fh);
            }
          fclose(fh);
        }
      strcpy(CPuffer,"");
    }

  /* Old Configuration File */
  if (strlen(CPuffer)>0)
    {
      Viewerror(5);

      /* read from preffile */
      if ((fh=fopen(APuffer,"r"))!=NULL)
        {
          
          /* Windows Position */
          if (fgets(BPuffer,255,fh)!=NULL)
            {
              memmove((BPuffer+strlen(BPuffer))-1,(BPuffer+strlen(BPuffer)),1);
              if (strcmp(BPuffer,"RIGHTUP")==0)
                {
                  xplogs.winpos=1;
                }
              if (strcmp(BPuffer,"RIGHTDOWN")==0)
                {
                  xplogs.winpos=2;
                }
              if (strcmp(BPuffer,"LEFTDOWN")==0)
                {
                  xplogs.winpos=3;
                }
              if (strcmp(BPuffer,"LEFTUP")==0)
                {
                  xplogs.winpos=4;
                }
            }

          /* PPP-Connect Script */
          if (fgets(BPuffer,255,fh)!=NULL)
            {
              memmove((BPuffer+strlen(BPuffer))-1,(BPuffer+strlen(BPuffer)),1);
              strcpy(xplogs.pppstart,BPuffer);
            }
          
          /* PPP-DisConnect Script */
          if (fgets(BPuffer,255,fh)!=NULL)
            {
              memmove((BPuffer+strlen(BPuffer))-1,(BPuffer+strlen(BPuffer)),1);
              strcpy(xplogs.pppstop,BPuffer);
            }

          /* Provider-Name */
          if (fgets(BPuffer,255,fh)!=NULL)
            {
              memmove((BPuffer+strlen(BPuffer))-1,(BPuffer+strlen(BPuffer)),1);
              strcpy(xplogs.provider,BPuffer);
            }
          
          /* User Buttons */
          if (fgets(BPuffer,255,fh)!=NULL)
            {
              memmove((BPuffer+strlen(BPuffer))-1,(BPuffer+strlen(BPuffer)),1);
              strcpy(xplogs.usera,BPuffer);
            }
          if (fgets(BPuffer,255,fh)!=NULL)
            {
              memmove((BPuffer+strlen(BPuffer))-1,(BPuffer+strlen(BPuffer)),1);
              strcpy(xplogs.userb,BPuffer);
            }
          if (fgets(BPuffer,255,fh)!=NULL)
            {
              memmove((BPuffer+strlen(BPuffer))-1,(BPuffer+strlen(BPuffer)),1);
              strcpy(xplogs.userc,BPuffer);
            }
          if (fgets(BPuffer,255,fh)!=NULL)
            {
              memmove((BPuffer+strlen(BPuffer))-1,(BPuffer+strlen(BPuffer)),1);
              strcpy(xplogs.useraa,BPuffer);
            }
          if (fgets(BPuffer,255,fh)!=NULL)
            {
              memmove((BPuffer+strlen(BPuffer))-1,(BPuffer+strlen(BPuffer)),1);
              strcpy(xplogs.userbb,BPuffer);
            }
          if (fgets(BPuffer,255,fh)!=NULL)
            {
              memmove((BPuffer+strlen(BPuffer))-1,(BPuffer+strlen(BPuffer)),1);
              strcpy(xplogs.usercc,BPuffer);
            }

          /* Rates-Table 7 = 70 */
          for (b=1 ; b<=70 ; b++)
            {
              if (fgets(BPuffer,255,fh)!=NULL)
                {
                  memmove((BPuffer+strlen(BPuffer))-1,(BPuffer+strlen(BPuffer)),1);
                  xplogs.xpqh[b]=atoi(BPuffer);
                }
              if (fgets(BPuffer,255,fh)!=NULL)
                {
                  memmove((BPuffer+strlen(BPuffer))-1,(BPuffer+strlen(BPuffer)),1);
                  xplogs.xpqm[b]=atoi(BPuffer);
                }
            }
          for (b=1 ; b<=70 ; b++)
            {
              if (fgets(BPuffer,255,fh)!=NULL)
                {
                  memmove((BPuffer+strlen(BPuffer))-1,(BPuffer+strlen(BPuffer)),1);
                  xplogs.xpqr[b]=atof(BPuffer);
                }
              if (fgets(BPuffer,255,fh)!=NULL)
                {
                  memmove((BPuffer+strlen(BPuffer))-1,(BPuffer+strlen(BPuffer)),1);
                  xplogs.xpqc[b]=atof(BPuffer);
                }
            }
          
          /* PhoneBill Activation */
          if (fgets(BPuffer,255,fh)!=NULL)
            {
              memmove((BPuffer+strlen(BPuffer))-1,(BPuffer+strlen(BPuffer)),1);
              if (strcmp(BPuffer,"PBPROTOCOL")==0)
                {
                  xplogs.PBProt=1;
                }
              if (strcmp(BPuffer,"NOPBPROTOCOL")==0)
                {
                  xplogs.PBProt=0;
                }
            }
          
          fclose(fh);
          
        }
    }

  
  if (xplogs.xpgui == 0)
    {

      xplMG.form = fl_bgn_form(FL_UP_BOX,268,148); 

      fl_set_border_width(2);

      /* Last and Actual Fields */
      xplMG.QPLovframe = fl_add_frame(FL_DOWN_FRAME,8,8,202,80,"");
      xplMG.QPLbegin = fl_add_frame(FL_DOWN_FRAME,12,12,60,20,_xpl_begin);
      fl_set_object_lalign(xplMG.QPLbegin,FL_ALIGN_LEFT);
      fl_set_object_lsize(xplMG.QPLbegin,FL_NORMAL_FONT);
      xplMG.QPLend = fl_add_frame(FL_DOWN_FRAME,12,38,60,20,_xpl_end);
      fl_set_object_lalign(xplMG.QPLend,FL_ALIGN_LEFT);
      fl_set_object_lsize(xplMG.QPLend,FL_NORMAL_FONT);
      xplMG.QPLduration = fl_add_frame(FL_DOWN_FRAME,12,64,60,20,_xpl_duration);
      fl_set_object_lalign(xplMG.QPLduration,FL_ALIGN_LEFT);
      fl_set_object_lsize(xplMG.QPLduration,FL_NORMAL_FONT);
      
      /* Output-Fields */
      xplMG.QPLlbegin = fl_add_box(FL_DOWN_BOX,74,10,134,24,"");
      fl_set_object_lalign(xplMG.QPLlbegin,FL_ALIGN_CENTER);
      fl_set_object_lstyle(xplMG.QPLlbegin,FL_FIXED_STYLE);
      fl_set_object_lsize(xplMG.QPLlbegin,FL_NORMAL_FONT);
      fl_set_object_label(xplMG.QPLlbegin,_xpl_name);
      xplMG.QPLlend = fl_add_box(FL_DOWN_BOX,74,36,134,24,"");
      fl_set_object_lalign(xplMG.QPLlend,FL_ALIGN_CENTER);
      fl_set_object_lstyle(xplMG.QPLlend,FL_FIXED_STYLE);
      fl_set_object_lsize(xplMG.QPLlend,FL_NORMAL_FONT);
      fl_set_object_label(xplMG.QPLlend,_xpl_copyright);
      xplMG.QPLlduration = fl_add_box(FL_DOWN_BOX,74,62,134,24,"");
      fl_set_object_lalign(xplMG.QPLlduration,FL_ALIGN_CENTER);
      fl_set_object_lstyle(xplMG.QPLlduration,FL_FIXED_STYLE);
      fl_set_object_lsize(xplMG.QPLlduration,FL_NORMAL_FONT);
      fl_set_object_label(xplMG.QPLlduration,_xpl_author);

      /* Control-Panel */
      xplMG.QPLcframe = fl_add_frame(FL_DOWN_FRAME,8,94,252,46,"");
      xplMG.QPLconnect = fl_add_button(FL_NORMAL_BUTTON,10,96,82,20,_xpl_connect);
      xplMG.QPLlogfile = fl_add_button(FL_NORMAL_BUTTON,94,96,40,20,_xpl_logfile);
      xplMG.QPLinfo = fl_add_button(FL_NORMAL_BUTTON,134,96,40,20,_xpl_info);
      xplMG.QPLphonebill = fl_add_button(FL_NORMAL_BUTTON,176,96,82,20,_xpl_phonebill);
      xplMG.QPLusera = fl_add_button(FL_NORMAL_BUTTON,10,118,82,20,xplogs.usera);
      xplMG.QPLuserb = fl_add_button(FL_NORMAL_BUTTON,94,118,80,20,xplogs.userb);
      xplMG.QPLuserc = fl_add_button(FL_NORMAL_BUTTON,176,118,82,20,xplogs.userc);
      
      /* Control Panel II */
      xplMG.QPLqframe = fl_add_frame(FL_DOWN_FRAME,216,8,44,80,"");
      xplMG.QPLquit = fl_add_button(FL_NORMAL_BUTTON,218,10,40,24,_xpl_quit);
      xplMG.QPLpref = fl_add_button(FL_NORMAL_BUTTON,218,36,40,24,_xpl_pref);
      xplMG.QPLhelp = fl_add_button(FL_NORMAL_BUTTON,218,62,40,24,_xpl_help);

      guif=0;
    }
  if (xplogs.xpgui == 1)
    {

      xplMG.form = fl_bgn_form(FL_UP_BOX,158,94); 

      fl_set_border_width(2);

      /* Output-Fields */
      xplMG.QPLlbegin = fl_add_box(FL_DOWN_BOX,6,6,124,20,"");
      fl_set_object_lalign(xplMG.QPLlbegin,FL_ALIGN_CENTER);
      fl_set_object_lstyle(xplMG.QPLlbegin,FL_FIXED_STYLE);
      fl_set_object_lsize(xplMG.QPLlbegin,FL_NORMAL_FONT);
      fl_set_object_label(xplMG.QPLlbegin,_xpl_name);
      xplMG.QPLlend = fl_add_box(FL_DOWN_BOX,6,26,124,20,"");
      fl_set_object_lalign(xplMG.QPLlend,FL_ALIGN_CENTER);
      fl_set_object_lstyle(xplMG.QPLlend,FL_FIXED_STYLE);
      fl_set_object_lsize(xplMG.QPLlend,FL_NORMAL_FONT);
      fl_set_object_label(xplMG.QPLlend,_xpl_copyright);
      xplMG.QPLlduration = fl_add_box(FL_DOWN_BOX,6,46,124,20,"");
      fl_set_object_lalign(xplMG.QPLlduration,FL_ALIGN_CENTER);
      fl_set_object_lstyle(xplMG.QPLlduration,FL_FIXED_STYLE);
      fl_set_object_lsize(xplMG.QPLlduration,FL_NORMAL_FONT);
      fl_set_object_label(xplMG.QPLlduration,_xpl_author);

      /* Control-Panel */
      xplMG.QPLconnect = fl_add_button(FL_NORMAL_BUTTON,6,68,20,20,"C");
      xplMG.QPLlogfile = fl_add_button(FL_NORMAL_BUTTON,28,68,20,20,"L");
      xplMG.QPLinfo = fl_add_button(FL_NORMAL_BUTTON,48,68,20,20,"I");
      xplMG.QPLphonebill = fl_add_button(FL_NORMAL_BUTTON,70,68,20,20,"P");
      xplMG.QPLusera = fl_add_button(FL_NORMAL_BUTTON,92,68,20,20,"1");
      xplMG.QPLuserb = fl_add_button(FL_NORMAL_BUTTON,112,68,20,20,"2");
      xplMG.QPLuserc = fl_add_button(FL_NORMAL_BUTTON,132,68,20,20,"3");
      
      /* Control Panel II */
      xplMG.QPLquit = fl_add_button(FL_NORMAL_BUTTON,132,6,20,20,"Q");
      xplMG.QPLpref = fl_add_button(FL_NORMAL_BUTTON,132,26,20,20,"P");
      xplMG.QPLhelp = fl_add_button(FL_NORMAL_BUTTON,132,46,20,20,"H");

      guif=1;
    }
  if (xplogs.xpgui == 2)
    {

      xplMG.form = fl_bgn_form(FL_UP_BOX,158,54); 

      fl_set_border_width(2);

      /* Output-Fields */
      xplMG.QPLlduration = fl_add_box(FL_DOWN_BOX,6,6,104,20,"");
      fl_set_object_lalign(xplMG.QPLlduration,FL_ALIGN_CENTER);
      fl_set_object_lstyle(xplMG.QPLlduration,FL_FIXED_STYLE);
      fl_set_object_lsize(xplMG.QPLlduration,FL_SMALL_FONT);
      fl_set_object_label(xplMG.QPLlduration,_xpl_name);

      /* Control-Panel */
      xplMG.QPLconnect = fl_add_button(FL_NORMAL_BUTTON,6,28,20,20,"C");
      xplMG.QPLlogfile = fl_add_button(FL_NORMAL_BUTTON,28,28,20,20,"L");
      xplMG.QPLinfo = fl_add_button(FL_NORMAL_BUTTON,48,28,20,20,"I");
      xplMG.QPLphonebill = fl_add_button(FL_NORMAL_BUTTON,70,28,20,20,"P");
      xplMG.QPLusera = fl_add_button(FL_NORMAL_BUTTON,92,28,20,20,"1");
      xplMG.QPLuserb = fl_add_button(FL_NORMAL_BUTTON,112,28,20,20,"2");
      xplMG.QPLuserc = fl_add_button(FL_NORMAL_BUTTON,132,28,20,20,"3");
      
      /* Control Panel II */
      xplMG.QPLquit = fl_add_button(FL_NORMAL_BUTTON,112,6,20,20,"Q");
      xplMG.QPLpref = fl_add_button(FL_NORMAL_BUTTON,132,6,20,20,"P");

      guif=2;
    }

  fl_end_form();

  /* Window Position */
  icommand=0;
  if (xplogs.FreeMove == 0)
    {
      fl_show_form(xplMG.form,FL_PLACE_GEOMETRY,FL_NOBORDER,_xpl_wintitle);
      
      if (xplogs.winpos == 1)
        { 
          fl_set_form_position(xplMG.form,-xplMG.form->w,0);
        }
      if (xplogs.winpos == 2)
        {
          fl_set_form_position(xplMG.form,-xplMG.form->w,-xplMG.form->h);
        }
      if (xplogs.winpos == 3)
        {
          fl_set_form_position(xplMG.form,0,-xplMG.form->h);
        }
      if (xplogs.winpos == 4)
        {
          fl_set_form_position(xplMG.form,0,0);
        }
      /* Window Iconify */
      if (xplogs.iconify == 1)
        {
          icommand=100;
        }

    }
  else
    {
      /* For Windows Correction */
      X11Flag=1;

      /* Window Iconify */
      if (xplogs.iconify == 1)
        {
          fl_show_form(xplMG.form,FL_PLACE_ICONIC,FL_FULLBORDER,_xpl_wintitle);
        }
      else
        {
          fl_show_form(xplMG.form,FL_PLACE_GEOMETRY,FL_FULLBORDER,_xpl_wintitle);
        }
      fl_set_form_position(xplMG.form,xplogs.xpos,xplogs.ypos);
     }
  
  xplMG.ready=0;
  while (xplMG.ready == 0)
    {
      xplMG.obj = fl_check_forms();

      /* Iconify */
      if (xplogs.FreeMove == 0)
        {
          /*win = fl_get_form_mouse(form,&winx,&winy,&wink);*/
          fl_get_form_mouse(xplMG.form,&winx,&winy,&wink);

          /* cout << winx << " " << winy << "\n"; */
          if (wink == 256)
            {
              if (xplogs.xpgui == 0)
                {
                  if ( (winx > 8 ) && (winx < 210) && (winy > 8) && (winy < 88) )
                    { 
                      icommand=100;
                    }
                }
              if (xplogs.xpgui == 1)
                {
                  if ( (winx > 6 ) && (winx < 130) && (winy > 6) && (winy < 66) )
                    { 
                      icommand=100;
                    }
                }
              if (xplogs.xpgui == 2)
                {
                  if ( (winx > 6 ) && (winx < 110) && (winy > 6) && (winy < 26) )
                    { 
                      icommand=100;
                    }
                }
            }
        }

      /* Internal Command - Iconify */
      if (icommand == 100)
        {
          fl_hide_form(xplMG.form);
          fl_show_form(xplMG.form,FL_PLACE_ICONIC,FL_FULLBORDER,"XPLog");
         
          icommand=0;
          while ( icommand == 0)
            {
              XGetWindowAttributes(fl_get_display(),xplMG.form->window,&attr);
              
              /* Logdatei gefunden */
              if ( (stat(PPP_PID,&statpuff) == 0) || (stat(IPPPD_PID,&statpuff) == 0) || (stat(IPPP_PID,&statpuff) == 0) )
                {
                  icommand=1;
                }

              /* Logdatei gefunden */
              if ( (stat("/test",&statpuff) == 0) )
                {
                  icommand=1;
                }

              /* Window Open ? */
              if (attr.map_state != IsUnmapped)
                {
                  icommand=1;
                }
              
              newSleep(250000);
            }

          fl_hide_form(xplMG.form);
          fl_show_form(xplMG.form,FL_PLACE_GEOMETRY,FL_NOBORDER,_xpl_wintitle);
                
          /* Window Position */
          if (xplogs.winpos == 1)
            {
              fl_set_form_position(xplMG.form,-xplMG.form->w,0);
            }
          if (xplogs.winpos == 2)
            {
              fl_set_form_position(xplMG.form,-xplMG.form->w,-xplMG.form->h);
            }
          if (xplogs.winpos == 3)
            {
              fl_set_form_position(xplMG.form,0,-xplMG.form->h);
            }
          if (xplogs.winpos == 4)
            {
              fl_set_form_position(xplMG.form,0,0);
            }
        }
     
      /* rates registration automatic */
      if (xplogs.xpmanual == 0)
        {
          /* Connect ? Yes */
          if (QPLcon == 0)
            {
              /* Check PID-File */
              if ( (stat(PPP_PID,&statpuff) == 0) || (stat(IPPPD_PID,&statpuff) == 0) || (stat(IPPP_PID,&statpuff) == 0) )
                {
                  atime = statpuff.st_mtime;
                  atm = localtime(&atime);
                  strftime(atimer,19,"%m/%d/%y %H:%M:%S",atm);
                  QPLcon = 1;
                  if (guif < 2)
                    {
                      fl_set_object_label(xplMG.QPLlbegin,atimer);
                      fl_set_object_color(xplMG.QPLlbegin,FL_WHEAT,FL_YELLOW);
                      fl_set_object_color(xplMG.QPLlend,FL_WHEAT,FL_YELLOW);
                    }
                  fl_set_object_color(xplMG.QPLlduration,FL_WHEAT,FL_YELLOW);
                  strcpy(APuffer,_xpl_disconnect);
                  if (guif > 0)
                    {
                      strcpy(APuffer,"D");
                    }           
                  fl_set_object_label(xplMG.QPLconnect,APuffer);
                }
            }
          if (QPLcon == 1)
            {
              /* Check PID-File */
              if ( ((fh=fopen(PPP_PID,"r")) != NULL) || ((fh=fopen(IPPPD_PID,"r")) != NULL) || ((fh=fopen(IPPP_PID,"r")) != NULL) )
                {
                  fclose(fh);
                  btime = time(0);
                  btm = localtime(&btime);
                  strftime(btimer,19,"%m/%d/%y %H:%M:%S",btm);
                  QPLcon = 1;
                  if (guif < 2)
                    {
                      fl_set_object_label(xplMG.QPLlend,btimer);
                    }
                  /* Online-Time */
                  strdef = strDiffTime(atime,btime);
                  strcpy(APuffer,strdef);
                  strcat(APuffer," ");
                  /* Phonecosts */
                  strdef=DoubleStr(phcalc(atime,btime)/100);
                  strcat(APuffer,strdef);
                  fl_set_object_label(xplMG.QPLlduration,APuffer);
                }
              else
                {
                  /* Save Entry */
                  QPLcon = 0;
                  /* create logfile path */
                  strcpy(APuffer,xpuser);
                  strcat(APuffer,"/.xplog.log");
                  /* create entry */
                  strcpy(BPuffer,atimer);
                  strcat(BPuffer," - ");
                  strcat(BPuffer,btimer);
                  strcat(BPuffer," ");
                  strcat(BPuffer,xplogs.provider);
                  strcat(BPuffer,"\n");
                  
                  /* write into logfile */
                  if ((fh=fopen(APuffer,"ab"))!=NULL)
                    {
                      a=fputs(BPuffer,fh);
                      fclose(fh);
                      chmod(APuffer,S_IRUSR|S_IWUSR);
                    }
                    
                  if (guif < 2)
                    {
                      fl_set_object_color(xplMG.QPLlbegin,FL_COL1,FL_YELLOW);
                      fl_set_object_color(xplMG.QPLlend,FL_COL1,FL_YELLOW);
                    }
                  fl_set_object_color(xplMG.QPLlduration,FL_COL1,FL_YELLOW);
                  strcpy(APuffer,_xpl_connect);
                  if (guif > 0)
                    {
                      strcpy(APuffer,"C");
                    }
                  fl_set_object_label(xplMG.QPLconnect,APuffer);
                  /* Iconify Mode ? */
                  if (xplogs.iconify == 1)
                    {
                      icommand=100;
                    }
                    
                  /* No ReDial */  
                  if (xplogs.noredial == 1)
                     {
                        a=system(xplogs.pppstop);
                        if (DEBUG == 1) cout << "No ReDial reached !!!\n";  
                     }
                } 
            }
        }

      /* Connect / Disconnect */
      if (xplMG.obj == xplMG.QPLconnect) 
        {
          if (QPLcon == 0)
            {
               atime = time(0);
               fl_deactivate_form(xplMG.form);
               if (CheckProtection(atime) == 0)            
               {            
                  a=system(xplogs.pppstart);
                  /* Errormessage */
                  if ((a == -1) || (a == 127) || (a == 32512))
                  {
                     if (xplogs.xpmess == 0)
                     {
                        Viewerror(1);
                     }
                  }
               }
               fl_activate_form(xplMG.form);
            }
          if (QPLcon == 1)
            {
              a=system(xplogs.pppstop);
              /* Errormessage */
              if ((a == -1) || (a == 127 ) || (a == 32512))
                {
                  if (xplogs.xpmess == 0)
                    {
                      Viewerror(2);
                    }
                }
            }
        }

      /* Viewlog */
      if (xplMG.obj == xplMG.QPLlogfile)
        {
          if (QPLcon == 0)
            {
              fl_deactivate_form(xplMG.form);
              Viewlog();
              fl_activate_form(xplMG.form);
            }
        }

      /* View Info */
      if (xplMG.obj == xplMG.QPLinfo)
        {
          if (QPLcon == 0)
            {
              fl_deactivate_form(xplMG.form);
              ratesinfo();
              fl_activate_form(xplMG.form);
            }
          else
            {
              ratesinfo();
            }
        }

      /* Phonebill */
      if (xplMG.obj == xplMG.QPLphonebill)
        {
          if (QPLcon == 0)
            {
              fl_deactivate_form(xplMG.form);
              phonebill();
              fl_activate_form(xplMG.form);
            }
        }

      /* User Buttons */
      if (xplMG.obj == xplMG.QPLusera)
        {
          a=system(xplogs.useraa);
          /* Errormessage */
          if ((a == -1) || (a == 127 ) || (a == 32512))
            {
              if (xplogs.xpmess == 0)
                {
                  Viewerror(3);
                }
            }
        }
      if (xplMG.obj == xplMG.QPLuserb)
        {
          a=system(xplogs.userbb);
          /* Errormessage */
          if ((a == -1) || (a == 127 ) || (a == 32512))
            {
              if (xplogs.xpmess == 0)
                {
                  Viewerror(3);
                }
            }
        }
      if (xplMG.obj == xplMG.QPLuserc)
        {
          a=system(xplogs.usercc);
          /* Errormessage */
          if ((a == -1) || (a == 127 ) || (a == 32512))
            {
              if (xplogs.xpmess == 0)
                {
                  Viewerror(3);
                }
            }
        }

      /* Quit */
      if (xplMG.obj == xplMG.QPLquit)
        {
          if (QPLcon == 0)
            {
              xplMG.ready=1;
            }
        }

      /* Help */
      if (xplMG.obj == xplMG.QPLhelp)
        {
          if (QPLcon == 0)
            {
              fl_deactivate_form(xplMG.form);
              Viewhelp();
              fl_activate_form(xplMG.form);
            }
        }

      /* Pref */
      if (xplMG.obj == xplMG.QPLpref)
        {
          if (QPLcon == 0)
            {
              fl_get_winorigin(xplMG.form->window,&xplogs.xpos,&xplogs.ypos);
              /* cout << xplogs.xpos << " " << xplogs.ypos << "\n"; */

              XGetWindowAttributes(fl_get_display(),xplMG.form->window,&attr);
              xplogs.xborder=attr.x;
              xplogs.yborder=attr.y;
              /* cout << xplogs.xborder << " " << xplogs.yborder << "\n"; */

              fl_hide_form(xplMG.form);
              Pref();

              /* GUI Switcher */
              if (guif != xplogs.xpgui)
                {
                  if (xplogs.xpmess == 0)
                    {
                      Viewerror(6);
                    }

                  /* Close Frame */
                  xpfl=1;
                  fl_free_form(xplMG.form);

                  a=system(XPLOG);

                  /* Errormessage */
                  if ((a < 0) || (a > 0))
                    {
                      Viewerror(7);
                    }
          
                  xplMG.ready=1;
                }

              /* Set Pref Selections */
              if (xpfl == 0)
                {
                  /* Window Position */
                  if (xplogs.FreeMove == 0)
                    {  
                      if (xplogs.winpos == 1)
                        { 
                          fl_set_form_position(xplMG.form,-xplMG.form->w,0);
                        }
                      if (xplogs.winpos == 2)
                        {
                          fl_set_form_position(xplMG.form,-xplMG.form->w,-xplMG.form->h);
                        }
                      if (xplogs.winpos == 3)
                        {
                          fl_set_form_position(xplMG.form,0,-xplMG.form->h);
                        }
                      if (xplogs.winpos == 4)
                        {
                          fl_set_form_position(xplMG.form,0,0);
                        }
                    }
                  else
                    {
                      if (X11Flag == 1)
                        {
                          X11Flag=0;
                          /* Window Position Correction */
                          xplogs.xpos=xplogs.xpos-xplogs.xborder;
                          xplogs.ypos=xplogs.ypos-xplogs.yborder;
                        }
                      fl_set_form_position(xplMG.form,xplogs.xpos,xplogs.ypos);
                    }

                  /* No Free movable Form */
                  if (xplogs.FreeMove == 0)
                    {
                      fl_show_form(xplMG.form,FL_PLACE_GEOMETRY,FL_NOBORDER,_xpl_wintitle);
                    }
                  else
                    {
                      fl_show_form(xplMG.form,FL_PLACE_GEOMETRY,FL_FULLBORDER,_xpl_wintitle);
                    }



                  if (guif == 0)
                    {
                      fl_set_object_label(xplMG.QPLusera,xplogs.usera);
                      fl_set_object_label(xplMG.QPLuserb,xplogs.userb);
                      fl_set_object_label(xplMG.QPLuserc,xplogs.userc);
                    }
                }

            }
        }
        
      /*   
      if (xpfl == 0)
        {
          newSleep(250000);
        }
      */
 
      newSleep(250000);
    }

  if (xpfl == 0)
    {
      fl_hide_form(xplMG.form);
    }

  return 0;
}

void Viewerror(int bug)
{
  struct xplViewError xplVE;
  char Puffer[1024];

  if (bug == 1)
    {
      strcpy(Puffer,_xpl_err1);
    }
  if (bug == 2)
    {
      strcpy(Puffer,_xpl_err2);
    }
  if (bug == 3)
    {
      strcpy(Puffer,_xpl_err3);
    }
  if (bug == 4)
    {
      strcpy(Puffer,_xpl_err4);
    }
  if (bug == 5)
    {
      strcpy(Puffer,_xpl_err5);
    }
  if (bug == 6)
    {
      strcpy(Puffer,_xpl_err6);
    }
  if (bug == 7)
    {
      strcpy(Puffer,_xpl_err7);
    }
  if (bug == 8)
    {
      strcpy(Puffer,_xpl_err8);
    }
  xplVE.form = fl_bgn_form(FL_UP_BOX,350,140); 

   fl_set_border_width(2);

   /* Browser */
   xplVE.viewfield = fl_add_frame(FL_DOWN_FRAME,10,10,330,92,Puffer);

   xplVE.QPLframe = fl_add_frame(FL_DOWN_FRAME,10,106,330,24,"");
   xplVE.QPLexit = fl_add_button(FL_NORMAL_BUTTON,145,108,60,20,_xpl_exit);

  fl_end_form();
      
  fl_show_form(xplVE.form,FL_PLACE_MOUSE,FL_FULLBORDER,_xpl_wintitle);
      
  xplVE.ready=0;
  while (xplVE.ready == 0)
    {
      xplVE.obj = fl_do_forms();

      /* Exit */
      if (xplVE.obj == xplVE.QPLexit)
        {
          xplVE.ready=1;      
        }

    }
      
  fl_hide_form(xplVE.form);

  return;

}
